function love.load()
	class = require "middleclass"

	require "scene"
	require "point"
	require "mouse"
	require "polygon"

	scene = Scene()
	mouse = Mouse(0.005)

	scene:add(Polygon( 0,0,-1, 0,1,-1, 1,1,-1, 1,0,-1 ):setColor(200, 70, 70))
	scene:add(Polygon( 0,0,-1, 0,1,-1, 1,1,-1, 1,0,-1 ):setColor(70, 70, 200):translate(0.25, 0.25, 0.5))

	love.mouse.setPosition(400, 300)
	love.mouse.setVisible(false)
end

function love.draw()
	scene:draw()
end

function love.update(dt)
	local moveSpeed = dt

	if love.keyboard.isDown('a') then
		scene:translate(moveSpeed, 0, 0)
	end
	if love.keyboard.isDown('d') then
		scene:translate(-moveSpeed, 0, 0)
	end
	if love.keyboard.isDown('w') then
		scene:translate(0, 0, moveSpeed)
	end
	if love.keyboard.isDown('s') then
		scene:translate(0, 0, -moveSpeed)
	end
	if love.keyboard.isDown(' ') then
		scene:translate(0, -moveSpeed, 0)
	end
	if love.keyboard.isDown('lshift') then
		scene:translate(0, moveSpeed, 0)
	end

	local dx, dy = mouse:update()
	scene:rotate(-dy, dx, 0)
end

function love.keypressed(k)
	if k == 'escape' then
		love.event.quit()
	end
end
