Point = class'Point'

function Point:initialize(...)
	self:setPosition(...)
end

function Point:getPosition()
	return self.x, self.y, self.z
end

function Point:setPosition(x, y, z)
	self.x = x or self.x or 0
	self.y = y or self.y or 0
	self.z = z or self.z or 0
	return self
end

function Point:translate(x, y, z)
	self.x = self.x + x
	self.y = self.y + y
	self.z = self.z + z
	return self
end

function Point:rotate(rx, ry, rz)
	local cosX, sinX = math.cos(rx), math.sin(rx)
	local cosY, sinY = math.cos(ry), math.sin(ry)
	local cosZ, sinZ = math.cos(rz), math.sin(rz)
	local x, y, z = self:getPosition()
	y, z = y * cosX + z * -sinX, y * sinX + z * cosX
	x, z = x * cosY + z * -sinY, x * sinY + z * cosY
	x, y = x * cosZ + y * -sinZ, x * sinZ + y * cosZ
	self:setPosition(x, y, z)
	return self
end

-- function rotateX(r)
-- 	local cosR = math.cos(r)
-- 	local sinR = math.sin(r)
-- 	for _, point in pairs(scene) do
-- 		local y, z = point.y, point.z
-- 		point.y = y * cosR + z * -sinR
-- 		point.z = y * sinR + z * cosR
-- 	end
-- end

-- function rotateY(r)
-- 	local cosR = math.cos(r)
-- 	local sinR = math.sin(r)
-- 	for _, point in pairs(scene) do
-- 		local x, z = point.x, point.z
-- 		point.x = x * cosR + z * -sinR
-- 		point.z = x * sinR + z * cosR
-- 	end
-- end

-- function rotateZ(r)
-- 	local cosR = math.cos(r)
-- 	local sinR = math.sin(r)
-- 	for _, point in pairs(scene) do
-- 		local x, y = point.x, point.y
-- 		point.x = x * cosR + y * -sinR
-- 		point.y = x * sinR + y * cosR
-- 	end
-- end

function Point:getDrawCoords()
	local w, h = love.window.getDimensions()
	return w/2 + self.x / -self.z * Scene.scale, h/2 + self.y / self.z * Scene.scale
end

function Point:draw()
	if self.z < 0 then
		love.graphics.setPointSize(8 / -self.z)
		love.graphics.point(self:getDrawCoords())
	end
end
