Polygon = class'Polygon'

function Polygon:initialize(...)
	self.points = {}
	self.color = { 255, 255, 255 }

	local coords = {...}
	for i=1, #coords - 2, 3 do
		self:addPoint(coords[i], coords[i + 1], coords[i + 2])
	end
end

function Polygon:addPoint(x, y, z)
	table.insert(self.points, Point(x, y, z))
	return self
end

function Polygon:setColor(...)
	self.color = {...}
	return self
end

function Polygon:translate(...)
	for _,point in pairs(self.points) do
		point:translate(...)
	end
	return self
end

function Polygon:rotate(...)
	for _,point in pairs(self.points) do
		point:rotate(...)
	end
	return self
end

function Polygon:draw()
	local coords = {}
	for _,point in pairs(self.points) do
		local x, y = point:getDrawCoords()
		table.insert(coords, x)
		table.insert(coords, y)
	end

	love.graphics.setColor(self.color)
	love.graphics.setLineWidth(5)
	love.graphics.polygon('fill', coords)
end
