Scene = class'Scene'
Scene.static.scale = 500

local function sortByZ(a, b)
	return a.z > b.z
end

function Scene:initialize()
	self.objects = {}
end

function Scene:add(object)
	table.insert(self.objects, object)
end

function Scene:translate(...)
	for _, o in pairs(self.objects) do
		o:translate(...)
	end
end

function Scene:rotate(...)
	for _, o in pairs(self.objects) do
		o:rotate(...)
	end
end

function Scene:draw()
	for _, o in pairs(self.objects) do
		o:draw()
	end
end
